Botan 2.19.5 Crypto and TLS for C&

Public Member Functions | Static Public Member Functions | Protected Member Functions | List of all members
Botan::ChaCha Class Referencefinal

`#include <chacha.h>`

Inheritance diagram for Botan::ChaCha:

## Public Member Functions
| ChaCha (size_t rounds=20)
void | cipher (const uint8_t in[], uint8_t out[], size_t length) override
void | cipher1 (uint8_t buf[], size_t len)
void | clear () override
StreamCipher * | clone () const override
template<typename Alloc >
void | decrypt (std::vector< uint8_t, Alloc > &inout)
size_t | default_iv_length () const override
template<typename Alloc >
void | encipher (std::vector< uint8_t, Alloc > &inout)
template<typename Alloc >
void | encrypt (std::vector< uint8_t, Alloc > &inout)
Key_Length_Specification | key_spec () const override
size_t | maximum_keylength () const
size_t | minimum_keylength () const
std::string | name () const override
std::string | provider () const override
void | seek (uint64_t offset) override
void | set_iv (const uint8_t iv[], size_t iv_len) override
template<typename Alloc >
void | set_key (const std::vector< uint8_t, Alloc > &key)
void | set_key (const SymmetricKey &key)
void | set_key (const uint8_t key[], size_t length)
bool | valid_iv_length (size_t iv_len) const override
bool | valid_keylength (size_t length) const
void | write_keystream (uint8_t out[], size_t len) override

## Static Public Member Functions
static std::unique_ptr< StreamCipher > | create (const std::string &algo_spec, const std::string &provider="")
static std::unique_ptr< StreamCipher > | create_or_throw (const std::string &algo_spec, const std::string &provider="")
static std::vector< std::string > | providers (const std::string &algo_spec)

## Protected Member Functions
void | verify_key_set (bool cond) const

## Detailed Description

DJB's ChaCha (https://cr.yp.to/chacha.html)

Definition at line 20 of file chacha.h.

## Constructor & Destructor Documentation

## ◆ ChaCha()

Botan::ChaCha::ChaCha | ( | size_t | rounds = `20` | ) |
| explicit

Parameters

  rounds | number of rounds

Note
  Currently only 8, 12 or 20 rounds are supported, all others will throw an exception

Definition at line 63 of file chacha.cpp.

63 : m_rounds(rounds)
64 {
65 BOTAN_ARG_CHECK(m_rounds == 8 || m_rounds == 12 || m_rounds == 20,
66 "ChaCha only supports 8, 12 or 20 rounds");
67 }
BOTAN_ARG_CHECK
#define BOTAN_ARG_CHECK(expr, msg)
Definition: assert.h:37

References BOTAN_ARG_CHECK.

Referenced by clone().

## Member Function Documentation

## ◆ cipher()

void Botan::ChaCha::cipher | ( | const uint8_t | in[],
|  | uint8_t | out[],
|  | size_t | len
| ) |  |
| override virtual

Encrypt or decrypt a message

Parameters

  in | the plaintext
  out | the byte array to hold the output, i.e. the ciphertext
  len | the length of both in and out in bytes

Implements Botan::StreamCipher.

Definition at line 174 of file chacha.cpp.

175 {
176 verify_key_set(m_state.empty() == false);
177
178 while(length >= m_buffer.size() - m_position)
179 {
180 const size_t available = m_buffer.size() - m_position;
181
182 xor_buf(out, in, &m_buffer[m_position], available);
183 chacha_x8(m_buffer.data(), m_state.data(), m_rounds);
184
185 length -= available;
186 in += available;
187 out += available;
188 m_position = 0;
189 }
190
191 xor_buf(out, in, &m_buffer[m_position], length);
192
193 m_position += length;
194 }
Botan::SymmetricAlgorithm::verify_key_set
void verify_key_set(bool cond) const
Definition: sym_algo.h:171
Botan::xor_buf
void xor_buf(uint8_t out[], const uint8_t in[], size_t length)
Definition: mem_ops.h:262

References Botan::SymmetricAlgorithm::verify_key_set(), and Botan::xor_buf().

## ◆ cipher1()

void Botan::StreamCipher::cipher1 | ( | uint8_t | buf[],
|  | size_t | len
| ) |  |
| inline inherited

Encrypt or decrypt a message The message is encrypted/decrypted in place.

Parameters

  buf | the plaintext / ciphertext
  len | the length of buf in bytes

Definition at line 78 of file stream_cipher.h.

79 { cipher(buf, buf, len); }
Botan::StreamCipher::cipher
virtual void cipher(const uint8_t in[], uint8_t out[], size_t len)=0

Referenced by Botan::SIV_Encryption::finish().

## ◆ clear()

void Botan::ChaCha::clear | ( |  | ) |
| override virtual

Reset the state.

Implements Botan::SymmetricAlgorithm.

Definition at line 354 of file chacha.cpp.

355 {
356 zap(m_key);
357 zap(m_state);
358 zap(m_buffer);
359 m_position = 0;
360 }
Botan::zap
void zap(std::vector< T, Alloc > &vec)
Definition: secmem.h:124

References Botan::zap().

## ◆ clone()

StreamCipher * Botan::ChaCha::clone | ( |  | ) | const
| override virtual

Returns
  a new object representing the same algorithm as *this

Implements Botan::StreamCipher.

Definition at line 290 of file chacha.cpp.

291 {
292 return new ChaCha(m_rounds);
293 }
Botan::ChaCha::ChaCha
ChaCha(size_t rounds=20)
Definition: chacha.cpp:63

References ChaCha().

## ◆ create()

std::unique_ptr< StreamCipher > Botan::StreamCipher::create | ( | const std::string & | algo_spec,
|  | const std::string & | provider = `""`
| ) |  |
| static inherited

Create an instance based on a name If provider is empty then best available is chosen.

Parameters

  algo_spec | algorithm name
  provider | provider implementation to use

Returns
  a null pointer if the algo/provider combination cannot be found

Definition at line 38 of file stream_cipher.cpp.

40 {
41 const SCAN_Name req(algo_spec);
42
43#if defined(BOTAN_HAS_CTR_BE)
44 if((req.algo_name() == "CTR-BE" || req.algo_name() == "CTR") && req.arg_count_between(1,2))
45 {
46 if(provider.empty() || provider == "base")
47 {
48 auto cipher = BlockCipher::create(req.arg(0));
49 if(cipher)
50 {
51 size_t ctr_size = req.arg_as_integer(1, cipher->block_size());
52 return std::unique_ptr<StreamCipher>(new CTR_BE(cipher.release(), ctr_size));
53 }
54 }
55 }
56#endif
57
58#if defined(BOTAN_HAS_CHACHA)
59 if(req.algo_name() == "ChaCha")
60 {
61 if(provider.empty() || provider == "base")
62 return std::unique_ptr<StreamCipher>(new ChaCha(req.arg_as_integer(0, 20)));
63 }
64
65 if(req.algo_name() == "ChaCha20")
66 {
67 if(provider.empty() || provider == "base")
68 return std::unique_ptr<StreamCipher>(new ChaCha(20));
69 }
70#endif
71
72#if defined(BOTAN_HAS_SALSA20)
73 if(req.algo_name() == "Salsa20")
74 {
75 if(provider.empty() || provider == "base")
76 return std::unique_ptr<StreamCipher>(new Salsa20);
77 }
78#endif
79
80#if defined(BOTAN_HAS_SHAKE_CIPHER)
81 if(req.algo_name() == "SHAKE-128" || req.algo_name() == "SHAKE-128-XOF")
82 {
83 if(provider.empty() || provider == "base")
84 return std::unique_ptr<StreamCipher>(new SHAKE_128_Cipher);
85 }
86#endif
87
88#if defined(BOTAN_HAS_OFB)
89 if(req.algo_name() == "OFB" && req.arg_count() == 1)
90 {
91 if(provider.empty() || provider == "base")
92 {
93 if(auto c = BlockCipher::create(req.arg(0)))
94 return std::unique_ptr<StreamCipher>(new OFB(c.release()));
95 }
96 }
97#endif
98
99#if defined(BOTAN_HAS_RC4)
100
101 if(req.algo_name() == "RC4" ||
102 req.algo_name() == "ARC4" ||
103 req.algo_name() == "MARK-4")
104 {
105 const size_t skip = (req.algo_name() == "MARK-4") ? 256 : req.arg_as_integer(0, 0);
106
107 if(provider.empty() || provider == "base")
108 {
109 return std::unique_ptr<StreamCipher>(new RC4(skip));
110 }
111 }
112
113#endif
114
115 BOTAN_UNUSED(req);
116 BOTAN_UNUSED(provider);
117
118 return nullptr;
119 }
BOTAN_UNUSED
#define BOTAN_UNUSED(...)
Definition: assert.h:142
Botan::BlockCipher::create
static std::unique_ptr< BlockCipher > create(const std::string &algo_spec, const std::string &provider="")
Definition: block_cipher.cpp:104
Botan::StreamCipher::provider
virtual std::string provider() const
Definition: stream_cipher.h:142

References Botan::SCAN_Name::algo_name(), Botan::SCAN_Name::arg(), Botan::SCAN_Name::arg_as_integer(), Botan::SCAN_Name::arg_count(), Botan::SCAN_Name::arg_count_between(), BOTAN_UNUSED, Botan::StreamCipher::cipher(), Botan::BlockCipher::create(), and Botan::StreamCipher::provider().

Referenced by Botan::Cipher_Mode::create(), Botan::BlockCipher::create(), and Botan::StreamCipher::create_or_throw().

## ◆ create_or_throw()

std::unique_ptr< StreamCipher > Botan::StreamCipher::create_or_throw | ( | const std::string & | algo_spec,
|  | const std::string & | provider = `""`
| ) |  |
| static inherited

Create an instance based on a name If provider is empty then best available is chosen.

Parameters

  algo_spec | algorithm name
  provider | provider implementation to use Throws a Lookup_Error if the algo/provider combination cannot be found

Definition at line 123 of file stream_cipher.cpp.

125 {
126 if(auto sc = StreamCipher::create(algo, provider))
127 {
128 return sc;
129 }
130 throw Lookup_Error("Stream cipher", algo, provider);
131 }
Botan::StreamCipher::create
static std::unique_ptr< StreamCipher > create(const std::string &algo_spec, const std::string &provider="")
Definition: stream_cipher.cpp:38

References Botan::StreamCipher::create(), and Botan::StreamCipher::provider().

Referenced by Botan::ChaCha_RNG::ChaCha_RNG(), Botan::Sodium::crypto_secretbox_detached(), Botan::Sodium::crypto_secretbox_open_detached(), Botan::Sodium::crypto_secretbox_xsalsa20poly1305(), Botan::Sodium::crypto_secretbox_xsalsa20poly1305_open(), Botan::Sodium::crypto_stream_chacha20(), Botan::Sodium::crypto_stream_chacha20_ietf(), Botan::Sodium::crypto_stream_chacha20_ietf_xor_ic(), Botan::Sodium::crypto_stream_chacha20_xor_ic(), Botan::Sodium::crypto_stream_xchacha20(), and Botan::Sodium::crypto_stream_xchacha20_xor_ic().

## ◆ decrypt()

template<typename Alloc >

void Botan::StreamCipher::decrypt | ( | std::vector< uint8_t, Alloc > & | inout | ) |
| inline inherited

Decrypt a message in place The message is decrypted in place.

Parameters

  inout | the plaintext / ciphertext

Definition at line 105 of file stream_cipher.h.

106 { cipher(inout.data(), inout.data(), inout.size()); }

## ◆ default_iv_length()

size_t Botan::ChaCha::default_iv_length | ( |  | ) | const
| override virtual

Return the default (preferred) nonce length If this function returns 0, then this cipher does not support nonces

Reimplemented from Botan::StreamCipher.

Definition at line 280 of file chacha.cpp.

281 {
282 return 24;
283 }

## ◆ encipher()

template<typename Alloc >

void Botan::StreamCipher::encipher | ( | std::vector< uint8_t, Alloc > & | inout | ) |
| inline inherited

Encrypt a message The message is encrypted/decrypted in place.

Parameters

  inout | the plaintext / ciphertext

Definition at line 87 of file stream_cipher.h.

88 { cipher(inout.data(), inout.data(), inout.size()); }

## ◆ encrypt()

template<typename Alloc >

void Botan::StreamCipher::encrypt | ( | std::vector< uint8_t, Alloc > & | inout | ) |
| inline inherited

Encrypt a message The message is encrypted in place.

Parameters

  inout | the plaintext / ciphertext

Definition at line 96 of file stream_cipher.h.

97 { cipher(inout.data(), inout.data(), inout.size()); }

## ◆ key_spec()

Key_Length_Specification Botan::ChaCha::key_spec | ( |  | ) | const
| override virtual

Returns
  object describing limits on key size

Implements Botan::SymmetricAlgorithm.

Definition at line 285 of file chacha.cpp.

286 {
287 return Key_Length_Specification(16, 32, 16);
288 }

## ◆ maximum_keylength()

size_t Botan::SymmetricAlgorithm::maximum_keylength | ( |  | ) | const
| inline inherited

Returns
  maximum allowed key length

Definition at line 120 of file sym_algo.h.

121 {
122 return key_spec().maximum_keylength();
123 }
Botan::Key_Length_Specification::maximum_keylength
size_t maximum_keylength() const
Definition: sym_algo.h:70
Botan::SymmetricAlgorithm::key_spec
virtual Key_Length_Specification key_spec() const =0

## ◆ minimum_keylength()

size_t Botan::SymmetricAlgorithm::minimum_keylength | ( |  | ) | const
| inline inherited

Returns
  minimum allowed key length

Definition at line 128 of file sym_algo.h.

129 {
130 return key_spec().minimum_keylength();
131 }
Botan::Key_Length_Specification::minimum_keylength
size_t minimum_keylength() const
Definition: sym_algo.h:62

Referenced by botan_block_cipher_get_keyspec(), and botan_mac_get_keyspec().

## ◆ name()

std::string Botan::ChaCha::name | ( |  | ) | const
| override virtual

Returns
  the algorithm name

Implements Botan::SymmetricAlgorithm.

Definition at line 362 of file chacha.cpp.

363 {
364 return "ChaCha(" + std::to_string(m_rounds) + ")";
365 }
Botan::ASN1::to_string
std::string to_string(const BER_Object &obj)
Definition: asn1_obj.cpp:213

References Botan::ASN1::to_string().

Referenced by set_iv().

## ◆ provider()

std::string Botan::ChaCha::provider | ( |  | ) | const
| override virtual

Returns
  provider information about this implementation. Default is "base", might also return "sse2", "avx2", "openssl", or some other arbitrary string.

Reimplemented from Botan::StreamCipher.

Definition at line 69 of file chacha.cpp.

70 {
71#if defined(BOTAN_HAS_CHACHA_AVX2)
72 if(CPUID::has_avx2())
73 {
74 return "avx2";
75 }
76#endif
77
78#if defined(BOTAN_HAS_CHACHA_SIMD32)
79 if(CPUID::has_simd_32())
80 {
81 return "simd32";
82 }
83#endif
84
85 return "base";
86 }
Botan::CPUID::has_simd_32
static bool has_simd_32()
Definition: cpuid.cpp:16

References Botan::CPUID::has_simd_32().

## ◆ providers()

std::vector< std::string > Botan::StreamCipher::providers | ( | const std::string & | algo_spec | ) |
| static inherited

Returns
  list of available providers for this algorithm, empty if not available

Definition at line 133 of file stream_cipher.cpp.

134 {
135 return probe_providers_of<StreamCipher>(algo_spec, {"base"});
136 }

## ◆ seek()

void Botan::ChaCha::seek | ( | uint64_t | offset | ) |
| override virtual

Set the offset and the state used later to generate the keystream

Parameters

  offset | the offset where we begin to generate the keystream

Implements Botan::StreamCipher.

Definition at line 367 of file chacha.cpp.

368 {
369 verify_key_set(m_state.empty() == false);
370
371 // Find the block offset
372 const uint64_t counter = offset / 64;
373
374 uint8_t out[8];
375
376 store_le(counter, out);
377
378 m_state[12] = load_le<uint32_t>(out, 0);
379 m_state[13] += load_le<uint32_t>(out, 1);
380
381 chacha_x8(m_buffer.data(), m_state.data(), m_rounds);
382 m_position = offset % 64;
383 }
Botan::load_le< uint32_t >
uint32_t load_le< uint32_t >(const uint8_t in[], size_t off)
Definition: loadstor.h:198
Botan::store_le
void store_le(uint16_t in, uint8_t out[2])
Definition: loadstor.h:454

References Botan::load_le< uint32_t >(), Botan::store_le(), and Botan::SymmetricAlgorithm::verify_key_set().

## ◆ set_iv()

void Botan::ChaCha::set_iv | ( | const uint8_t | iv[],
|  | size_t | iv_len
| ) |  |
| override virtual

Resync the cipher using the IV

Parameters

  iv | the initialization vector
  iv_len | the length of the IV in bytes

Implements Botan::StreamCipher.

Definition at line 300 of file chacha.cpp.

301 {
302 verify_key_set(m_state.empty() == false);
303
304 if(!valid_iv_length(length))
305 throw Invalid_IV_Length(name(), length);
306
307 initialize_state();
308
309 if(length == 0)
310 {
311 // Treat zero length IV same as an all-zero IV
312 m_state[14] = 0;
313 m_state[15] = 0;
314 }
315 else if(length == 8)
316 {
317 m_state[14] = load_le<uint32_t>(iv, 0);
318 m_state[15] = load_le<uint32_t>(iv, 1);
319 }
320 else if(length == 12)
321 {
322 m_state[13] = load_le<uint32_t>(iv, 0);
323 m_state[14] = load_le<uint32_t>(iv, 1);
324 m_state[15] = load_le<uint32_t>(iv, 2);
325 }
326 else if(length == 24)
327 {
328 m_state[12] = load_le<uint32_t>(iv, 0);
329 m_state[13] = load_le<uint32_t>(iv, 1);
330 m_state[14] = load_le<uint32_t>(iv, 2);
331 m_state[15] = load_le<uint32_t>(iv, 3);
332
333 secure_vector<uint32_t> hc(8);
334 hchacha(hc.data(), m_state.data(), m_rounds);
335
336 m_state[ 4] = hc[0];
337 m_state[ 5] = hc[1];
338 m_state[ 6] = hc[2];
339 m_state[ 7] = hc[3];
340 m_state[ 8] = hc[4];
341 m_state[ 9] = hc[5];
342 m_state[10] = hc[6];
343 m_state[11] = hc[7];
344 m_state[12] = 0;
345 m_state[13] = 0;
346 m_state[14] = load_le<uint32_t>(iv, 4);
347 m_state[15] = load_le<uint32_t>(iv, 5);
348 }
349
350 chacha_x8(m_buffer.data(), m_state.data(), m_rounds);
351 m_position = 0;
352 }
Botan::ChaCha::name
std::string name() const override
Definition: chacha.cpp:362
Botan::ChaCha::valid_iv_length
bool valid_iv_length(size_t iv_len) const override
Definition: chacha.cpp:295

References Botan::load_le< uint32_t >(), name(), valid_iv_length(), and Botan::SymmetricAlgorithm::verify_key_set().

Referenced by Botan::Sodium::randombytes_buf_deterministic().

## ◆ set_key() [1/3]

template<typename Alloc >

void Botan::SymmetricAlgorithm::set_key | ( | const std::vector< uint8_t, Alloc > & | key | ) |
| inline inherited

Definition at line 153 of file sym_algo.h.

154 {
155 set_key(key.data(), key.size());
156 }
Botan::SymmetricAlgorithm::set_key
void set_key(const SymmetricKey &key)
Definition: sym_algo.h:147

## ◆ set_key() [2/3]

void Botan::SymmetricAlgorithm::set_key | ( | const SymmetricKey & | key | ) |
| inline inherited

Set the symmetric key of this object.

Parameters

  key | the SymmetricKey to be set.

Definition at line 147 of file sym_algo.h.

148 {
149 set_key(key.begin(), key.length());
150 }

References Botan::OctetString::begin(), and Botan::OctetString::length().

Referenced by Botan::aont_package(), Botan::aont_unpackage(), botan_block_cipher_set_key(), botan_cipher_set_key(), botan_mac_set_key(), Botan::Sodium::crypto_stream_salsa20(), Botan::Sodium::crypto_stream_salsa20_xor_ic(), Botan::Sodium::crypto_stream_xsalsa20(), Botan::Sodium::crypto_stream_xsalsa20_xor_ic(), Botan::FPE::fe1_decrypt(), Botan::FPE::fe1_encrypt(), and Botan::Sodium::randombytes_buf_deterministic().

## ◆ set_key() [3/3]

void Botan::SymmetricAlgorithm::set_key | ( | const uint8_t | key[],
|  | size_t | length
| ) |  |
| inherited

Set the symmetric key of this object.

Parameters

  key | the to be set as a byte array.
  length | in bytes of key param

Definition at line 17 of file sym_algo.cpp.

18 {
19 if(!valid_keylength(length))
20 throw Invalid_Key_Length(name(), length);
21 key_schedule(key, length);
22 }
Botan::SymmetricAlgorithm::valid_keylength
bool valid_keylength(size_t length) const
Definition: sym_algo.h:138
Botan::SymmetricAlgorithm::name
virtual std::string name() const =0

References Botan::SymmetricAlgorithm::name(), and Botan::SymmetricAlgorithm::valid_keylength().

## ◆ valid_iv_length()

bool Botan::ChaCha::valid_iv_length | ( | size_t | iv_len | ) | const
| override virtual

Parameters

  iv_len | the length of the IV in bytes

Returns
  if the length is valid for this algorithm

Reimplemented from Botan::StreamCipher.

Definition at line 295 of file chacha.cpp.

296 {
297 return (iv_len == 0 || iv_len == 8 || iv_len == 12 || iv_len == 24);
298 }

Referenced by set_iv().

## ◆ valid_keylength()

bool Botan::SymmetricAlgorithm::valid_keylength | ( | size_t | length | ) | const
| inline inherited

Check whether a given key length is valid for this algorithm.

Parameters

  length | the key length to be checked.

Returns
  true if the key length is valid.

Definition at line 138 of file sym_algo.h.

139 {
140 return key_spec().valid_keylength(length);
141 }
Botan::Key_Length_Specification::valid_keylength
bool valid_keylength(size_t length) const
Definition: sym_algo.h:52

Referenced by Botan::aont_package(), Botan::aont_unpackage(), and Botan::SymmetricAlgorithm::set_key().

## ◆ verify_key_set()

void Botan::SymmetricAlgorithm::verify_key_set | ( | bool | cond | ) | const
| inline protected inherited

Definition at line 171 of file sym_algo.h.

172 {
173 if(cond == false)
174 throw_key_not_set_error();
175 }

Referenced by cipher(), Botan::CTR_BE::cipher(), Botan::RC4::cipher(), Botan::Salsa20::cipher(), Botan::SHAKE_128_Cipher::cipher(), Botan::AES_128::decrypt_n(), Botan::AES_192::decrypt_n(), Botan::AES_256::decrypt_n(), Botan::ARIA_128::decrypt_n(), Botan::ARIA_192::decrypt_n(), Botan::ARIA_256::decrypt_n(), Botan::Blowfish::decrypt_n(), Botan::Camellia_128::decrypt_n(), Botan::Camellia_192::decrypt_n(), Botan::Camellia_256::decrypt_n(), Botan::CAST_128::decrypt_n(), Botan::CAST_256::decrypt_n(), Botan::DES::decrypt_n(), Botan::TripleDES::decrypt_n(), Botan::DESX::decrypt_n(), Botan::GOST_28147_89::decrypt_n(), Botan::IDEA::decrypt_n(), Botan::KASUMI::decrypt_n(), Botan::Lion::decrypt_n(), Botan::MISTY1::decrypt_n(), Botan::Noekeon::decrypt_n(), Botan::SEED::decrypt_n(), Botan::Serpent::decrypt_n(), Botan::SHACAL2::decrypt_n(), Botan::SM4::decrypt_n(), Botan::Threefish_512::decrypt_n(), Botan::Twofish::decrypt_n(), Botan::XTEA::decrypt_n(), Botan::AES_128::encrypt_n(), Botan::AES_192::encrypt_n(), Botan::AES_256::encrypt_n(), Botan::ARIA_128::encrypt_n(), Botan::ARIA_192::encrypt_n(), Botan::ARIA_256::encrypt_n(), Botan::Blowfish::encrypt_n(), Botan::Camellia_128::encrypt_n(), Botan::Camellia_192::encrypt_n(), Botan::Camellia_256::encrypt_n(), Botan::CAST_128::encrypt_n(), Botan::CAST_256::encrypt_n(), Botan::DES::encrypt_n(), Botan::TripleDES::encrypt_n(), Botan::DESX::encrypt_n(), Botan::GOST_28147_89::encrypt_n(), Botan::IDEA::encrypt_n(), Botan::KASUMI::encrypt_n(), Botan::Lion::encrypt_n(), Botan::MISTY1::encrypt_n(), Botan::Noekeon::encrypt_n(), Botan::SEED::encrypt_n(), Botan::Serpent::encrypt_n(), Botan::SHACAL2::encrypt_n(), Botan::SM4::encrypt_n(), Botan::Threefish_512::encrypt_n(), Botan::Twofish::encrypt_n(), Botan::XTEA::encrypt_n(), Botan::OCB_Encryption::finish(), Botan::OCB_Decryption::finish(), Botan::GHASH::ghash_update(), Botan::CFB_Encryption::process(), Botan::CFB_Decryption::process(), seek(), Botan::CTR_BE::seek(), Botan::Salsa20::seek(), Botan::OCB_Mode::set_associated_data(), set_iv(), Botan::Salsa20::set_iv(), Botan::GHASH::update(), Botan::GHASH::update_associated_data(), and write_keystream().

## ◆ write_keystream()

void Botan::ChaCha::write_keystream | ( | uint8_t | out[],
|  | size_t | len
| ) |  |
| override virtual

Write keystream bytes to a buffer

Parameters

  out | the byte array to hold the keystream
  len | the length of out in bytes

Reimplemented from Botan::StreamCipher.

Definition at line 196 of file chacha.cpp.

197 {
198 verify_key_set(m_state.empty() == false);
199
200 while(length >= m_buffer.size() - m_position)
201 {
202 const size_t available = m_buffer.size() - m_position;
203
204 copy_mem(out, &m_buffer[m_position], available);
205 chacha_x8(m_buffer.data(), m_state.data(), m_rounds);
206
207 length -= available;
208 out += available;
209 m_position = 0;
210 }
211
212 copy_mem(out, &m_buffer[m_position], length);
213
214 m_position += length;
215 }
Botan::copy_mem
void copy_mem(T *out, const T *in, size_t n)
Definition: mem_ops.h:133

References Botan::copy_mem(), and Botan::SymmetricAlgorithm::verify_key_set().

Referenced by Botan::Sodium::randombytes_buf_deterministic().

The documentation for this class was generated from the following files:

- src/lib/stream/chacha/chacha.h
- src/lib/stream/chacha/chacha.cpp
- src/lib/stream/chacha/chacha_avx2/chacha_avx2.cpp
- src/lib/stream/chacha/chacha_simd32/chacha_simd32.cpp